package com.dragoninfo.dcuc.authweb.restcontroller.approval.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;


@Data
@ApiModel(value = "动态授权资源Vo")
public class FuncApprovalVo {

    //编号
    @ApiModelProperty(value = "id")
    private String id;

    //应用ID
    @ApiModelProperty(value = "应用ID")
    private String appId;

    //应用名称
    @ApiModelProperty(value = "应用名称")
    private String appName;

    //功能id
    @ApiModelProperty(value = "功能id")
    private String funcId;

    //功能名称
    @ApiModelProperty(value = "功能名称")
    private String funcName;

    //角色id
    @ApiModelProperty(value = "角色id")
    private String roleId;

    //申请单位
    @ApiModelProperty(value = "申请单位")
    private String proposerOrg;

    //申请人
    @ApiModelProperty(value = "申请人id")
    private String proposerId;

    //申请人身份证
    @ApiModelProperty(value = "申请人身份证")
    private String proposerIdcard;

    //申请时间
    @ApiModelProperty(value = "申请时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
    private Date proposerTime;

    //申请事由
    @ApiModelProperty(value = "申请事由")
    private String proposerReason;

    //审核状态：-1：审批中 0：未通过 1：通过
    @ApiModelProperty(value = "审核状态")
    private String approvalStatus;

    //审批意见
    @ApiModelProperty(value = "审批意见")
    private String approvalOpinion;

    //审批时间
    @ApiModelProperty(value = "审批时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
    private Date approvalTime;

    //审批人
    @ApiModelProperty(value = "审批人id")
    private String approvalId;

    //有效标志(0：无效 1：有效)
    @ApiModelProperty(value = "有效标志")
    private String isActive;

    //角色名称
    @ApiModelProperty(value = "角色名称")
    private String roleName;

    //申请人名称
    @ApiModelProperty(value = "申请人名称")
    private String proposerName;

    //调用次数
    @ApiModelProperty(value = "调用次数")
    private int callTime;

    //申请人机构名称
    @ApiModelProperty(value = "申请人机构名称")
    private String orgName;

    //审批人名称
    @ApiModelProperty(value = "审批人名称")
    private String approvalName;

    //审批人名称
    @ApiModelProperty(value = "hasTime,0：不存在时间限制 1：存在时间限制")
    private String hasTime;

    //审批人名称
    @ApiModelProperty(value = "权限有效期限 格式：yyyyMMddHHmmss")
    private String validTime;


}
